datablock AudioProfile(spitfireFireSound)
{
   filename    = "./Fire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SpitfireidleSound)
{
   filename    = "./sounds/idle.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};


datablock AudioProfile(Spitfirethrottle1Sound)
{
   filename    = "./sounds/cruise1.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};





datablock WheeledVehicleSpring(spitfireSpring)
{
   // Wheel suspension properties
   length = 0.4;        // Suspension trave
   force = 3000;        // Spring force
   damping = 2000;      // Spring damping
   antiSwayForce = 6;   // Lateral anti-sway force
};

datablock ParticleData(LightDamageParticle) 
{ 
textureName = "base/data/particles/smoke"; 
dragCoefficient = 2.0; 
gravityCoefficient = 0.3; 
inheritedVelFactor = 0.1; 
constantAcceleration = 0.0; 
lifetimeMS = 1200; 
lifetimeVarianceMS = 0; 
colors[0] = "0.46 0.46 0.46 1.0"; 
colors[1] = "0.2 0.2 0.2 0.2"; 
sizes[0] = 1.50; 
sizes[1] = 1.0; 
}; 

datablock ParticleEmitterData(LightDamageEmitter) 
{ 
ejectionPeriodMS = 3; 
periodVarianceMS = 0; 
ejectionVelocity = 6; 
velocityVariance = 3.0; 
ejectionOffset = 0.0; 
thetaMin = 5; 
thetaMax = 60; 
phiReferenceVel = 0; 
phiVariance = 360; 
overrideAdvances = false; 
particles = "LightDamageParticle"; 
}; 
datablock ParticleData(HeavyDamageParticle) 
{ 
textureName = "base/data/particles/smoke"; 
dragCoefficient = 2.0; 
gravityCoefficient = 0.3; 
inheritedVelFactor = 0.1; 
constantAcceleration = 0.0; 
lifetimeMS = 1200; 
lifetimeVarianceMS = 0; 
	useInvAlpha		= true;
	animateTexture		= false;
	colors[0]	= "0.0 0.0 0.0 0.7";
	colors[1]	= "0.0 0.0 0.0 0.2";

sizes[0] = 1.5; 
sizes[1] = 1.0; 
}; 

datablock ParticleEmitterData(HeavyDamageEmitter) 
{ 
ejectionPeriodMS = 3; 
periodVarianceMS = 0; 
ejectionVelocity = 6; 
velocityVariance = 3.0; 
ejectionOffset = 0.0; 
thetaMin = 5; 
thetaMax = 60; 
phiReferenceVel = 0; 
phiVariance = 360; 
overrideAdvances = false; 
particles = "HeavyDamageParticle"; 
}; 
datablock WheeledVehicleTire(spitfireTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "./spitfirewheel.dts";
	
	mass = 10;
   radius = 1;
   staticFriction = 2;
   kineticFriction = 2;
   restitution = 0.5;	

   // Spring that generates lateral tire forces
   lateralForce = 18000;
   lateralDamping = 4000;
   lateralRelaxation = 0.01;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 13000;
   longitudinalDamping = 2000;
   longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(spitfireSpring)
{
   // Wheel suspension properties
   length = 0.4;        // Suspension trave
   force = 2000;        // Spring force
   damping = 2000;      // Spring damping
   antiSwayForce = 6;   // Lateral anti-sway force
};
datablock WheeledVehicleTire(spitfirerearTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "./spitfirerear.dts";
	
	mass = 10;
   radius = 1;
   staticFriction = 2;//5
   kineticFriction = 2;
   restitution = 0.5;	

   // Spring that generates lateral tire forces
   lateralForce = 18000;
   lateralDamping = 4000;
   lateralRelaxation = 0.01;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 13000;
   longitudinalDamping = 2000;
   longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(spitfirerearSpring)
{
   // Wheel suspension properties
   length = 0.7;        // Suspension trave
   force = 1000;        // Spring force
   damping = 3000;      // Spring damping
   antiSwayForce = 2;   // Lateral anti-sway force
};




datablock WheeledVehicleData(spitfireVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./spitfirestrat2.dts"; //"~/data/shapes/skivehicle.dts"; //

	emap = true;
	minMountDist = 3;
   
   numMountPoints = 1;
   mountThread[0] = "sit";

shootonclickspitfire=1;
	 
shootonclickspitfire_Hold=1;
shootonclickspitfire_ShootDelay=70;
shootonclickspitfire_ReShootDelay=70;
shootonclickspitfire_ProjectileCount=2;
shootonclickspitfire_RequiredSlot=0;
shootonclickspitfire_Sound=spitfireFireSound;

shootonclickspitfire_Projectile[0]=gunProjectile;
shootonclickspitfire_Position[0]="2 -3 0";
shootonclickspitfire_Velocity[0]="200 0 0";
shootonclickspitfire_Scale[0]="1 1 1";

shootonclickspitfire_Projectile[1]=gunProjectile;
shootonclickspitfire_Position[1]="2 3 0";
shootonclickspitfire_Velocity[1]="200 0 0";
shootonclickspitfire_Scale[1]="1 1 1";



	maxDamage = 100.00;
	destroyedLevel = 200.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 50.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 13;         // Far distance from vehicle
	cameraOffset = 6;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = true;	//exec("add-ons/vehicle_spitfire/vehicle_spitfire.cs");

	defaultTire	  = spitfireTire;
	defaultSpring = spitfireSpring;
	//flatTire	     = spitfireFlatTire;
	//flatSpring	  = spitfireFlatSpring;

   numWheels = 3;

	// Rigid Body
	mass = 200;
	density = 5.0;
	drag = 0.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 400; //4000;       // Engine power
	engineBrake = 300;         // Braking when throttle is 0
	brakeTorque = 3000;        // When brakes are applied
	maxWheelSpeed = 20;        // Engine scale by current speed / max speed

	rollForce		= 12000;
	yawForce		= 12000;
	pitchForce		= 12000;
	rotationalDrag		= 0.2;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

   isSled = false;

   forwardThrust		= 3000;
	reverseThrust		= 20;
	lift			= 10;
	maxForwardVel		= 40;
	maxReverseVel		= 20;
	horizontalSurfaceForce	= 130;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 130; 
	rollForce		= 8000;
	yawForce		= 4000;
	pitchForce		= 4000;
	rotationalDrag		= 0.5;
	stallSpeed		= 5;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Spitfire";
	rideable = true;
		lookUpLimit = 0.57;
		lookDownLimit = 0.57;

	paintable = true;
   damageEmitter[0] = LightDamageEmitter; 
   	damageEmitterOffset[0] = "0.0 3.0 0.5 ";
		damageLevelTolerance[0] = 0.35;
	
damageEmitter[1] = HeavyDamageEmitter; 
	damageEmitterOffset[1] = "0.0 3.0 0.0 ";
		damageLevelTolerance[1] = 0.7;
	
	
   damageEmitter[2] = VehicleBurnEmitter;
	damageEmitterOffset[2] = "0.0 0.0 0.0 ";
	damageLevelTolerance[2] = 0.99;

   damageEmitter[3] = VehicleBurnEmitter;
	damageEmitterOffset[3] = "0.0 0.0 0.0 ";
	damageLevelTolerance[3] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = jeepExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = SpitfireFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now

   minSpitfireSpeed = 20;
   minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

   steeringUseStrafeSteering = false; //this vehicle has pitch control, so we can't use strafe steering
};


function spitfirevehicle::onadd(%this,%obj)
{ 
	parent::onadd(%this,%obj);
			   %obj.playThread(0,"spin");
			   	SpitfireSpeedCheck(%this, %obj);
	%obj.setWheelTire(0, spitfiretire);
	%obj.setWheelTire(1, spitfiretire);
	%obj.setWheelTire(2, spitfirereartire);

		%obj.setWheelSpring(0, spitfireSpring);
		%obj.setWheelSpring(1, spitfireSpring);
		%obj.setWheelSpring(2, spitfireSpring);
	
	%obj.setWheelSteering(0,0);
	%obj.setWheelSteering(1,0);
	%obj.setWheelSteering(2,-1);

	%obj.setWheelPowered(0,true);
  %obj.setWheelPowered(1,true);
	%obj.setWheelPowered(2,true);
}

function spitfireVehicle::onImpact(%this,%obj,%data)
{
	%speed = vectorLen(%obj.getVelocity());
	if(%speed > %obj.dataBlock.minspitfireSpeed)

		%trans = %obj.getTransform();

	%p = new Projectile()
	{
		dataBlock = SpitfireFinalExplosionProjectile;
		initialVelocity  = "0 0 0";
		initialPosition  = %trans;
		sourceObject     = %obj;
		sourceSlot       = 0;
		client           = %obj.client;
	};
	MissionCleanup.add(%p);
	         if(%obj.destroyed)
            return;
         %obj.setDamageLevel(%this.maxDamage);
         %obj.destroyed = 1;
         %obj.schedule(10,"finalExplosion");
         if(isObject(%obj.spawnBrick.client.minigame))
            %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
         %obj.spawnBrick.schedule(%respawn,"spawnVehicle");

	
}
datablock ExplosionData(SpitfireFinalExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = vehicleExplosionSound;
   
   emitter[0] = vehicleFinalExplosionEmitter3;
   emitter[1] = vehicleFinalExplosionEmitter2;

   particleEmitter = vehicleFinalExplosionEmitter;
   particleDensity = 20;
   particleRadius = 1.0;


   faceViewer     = true;
   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.75;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 20;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 15;
   impulseForce = 1000;
   impulseVertical = 2000;

   //radius damage
   damageRadius = 12;
   radiusDamage = 250;

   //burn the players?
   playerBurnTime = 5000;

};
datablock ProjectileData(SpitfireFinalExplosionProjectile)
{
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0;
   explosion           = SpitfireFinalExplosion;

   directDamageType  = $DamageType::jeepExplosion;
   radiusDamageType  = $DamageType::jeepExplosion;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 10;
};

function SpitfireSpeedCheck(%this, %obj)
{


	if(!isObject(%obj))
		return;

	%vehicle = %obj;
%slot = 0; //Play the sound in the driver's spot
	%speed = vectorLen(%obj.getVelocity());

	if(%speed < 0) //Keeps throwing random negative numbers when train is at dead stop
	    %speed = 0;

	if(%speed < 10)
	    %vehicle.playAudio(%slot, SpitfireidleSound);

	else if(%speed < 30)
	    %vehicle.playAudio(%slot, Spitfirethrottle1Sound);




	    

	schedule(500,0,"SpitfireSpeedCheck",%this,%obj);
}


